utility MExport "MeshExport" width:162 height:159
(
	button btn_export "Export to file" pos:[6,7] width:150 height:21
	button btn_help "Help" pos:[6,33] width:150 height:21


function DoSaveDialog=
(
fname = GetSaveFileName types:"Exports for YuraEngine (*.EYE)|*.EYE|All Files(*.*)|*.*|"
if fname == undefined then 
return "NoFileChosen"
ExportS=createfile fname
if exports==undefined then 
return undefined
return Exports
)

	on btn_export pressed do
	(
		EStream=DoSaveDialog()
		if EStream=="NoFileChosen" then
			close
		if EStream!=undefined then
		(
			--export all the selected meshes
			for node in selection do
			(
				if not ((SuperClassOf node == GeometryClass) and (ClassOf node == Editable_mesh)) then
				(
					--Export only in case an object is a mesh.
					Messagebox "Unable to export a non-mesh object! Click Ok to continue exporting other objects."
				)
				else
				(
					--Export the mesh to file
					format    ("%    %    %\n") node.numverts node.numfaces node.numTVerts to:EStream
					for i=1 to node.numverts do
					(
						format ("% % %\n") ((GetVert node i).x) ((GetVert node i).y) ((GetVert node i).z) to:EStream
					)
					for i=1 to node.numfaces do
					(
						format ("% % %\n") ((GetFace node i).x as integer) ((GetFace node i).y as integer) ((GetFace node i).z as integer) to:EStream
					)
					for i=1 to node.numTVerts do
					(
						format ("% % %\n") ((GetTVert node i).x) ((GetTVert node i).y) ((gettvert node i).z) to:EStream
					)
					for i=1 to node.numfaces do
					(
						format("% % %\n") ((GetTVFace node i).x as integer) ((GetTVFace node i).y as integer) ((GetTVFace node i).z as integer) to:EStream
					)
					
				)
			)
		)
		Close EStream
	
	)

	on btn_help pressed do
	(
	MessageBox "MeshExport will export your single 3d Studio Object to a textfile so that it would be openable for YuraEngineModel Editor. Select an object and click the Export button to file button to continue."
	)
)


